<?php
    /* Much revised 14 Sep 2006 to allow 'current' area of window to be
    kept visible */
    session_start();
    ob_start();
    if (isset($_POST["elizainput"]))
      /* Input available from form. Use it to run Eliza and build up output string */
      {
         if ($_POST["elizainput"]=="NEW")
         /* Input requested restart */
         {
           /*  session_unset(); */
           /*  session_destroy(); */
             echo "RESTART-NEW<br>";
             $_SESSION["conversation"]="";
             $popin="empty";
             $elizasoutput="";
         }
         else
         {
            /*Set up environment variables for poplog to use */
            /*Does this need to be done every time? */
            /*Probably better done by invoking basepop11 via a script that sets variables?*/
            putenv("usepop=cgi-bin/v15.6/v15.6");
            putenv("popsys=cgi-bin/v15.6/v15.6/pop/pop");
            putenv("popautolib=cgi-bin/v15.6/v15.6/pop/lib/auto");
            putenv("popexlinkbase=cgi-bin/v15.6/v15.6/pop/pop/basepop11.stb");
            /* Input from the form */
            $popin = $_POST["elizainput"];
            putenv("POPARGS=$popin");
            $popin = stripslashes($popin);
            $basepop ="cgi-bin/v15.6/v15.6/pop/pop/basepop11";
            $popexternlib ="cgi-bin/v15.6/v15.6/pop/extern/lib";
            /* dummay commands for testing */
            /* $elizasoutput=system("ls -l cgi-bin/v15.6/v15.6/pop"); */
            /* $elizasoutput=system("uname -rv "); */
            /* run eliza using the POPARGS variable to transfer input */
            $elizasoutput=system("$basepop %nort %nobanner ./cgi-bin/eliza2.p");
            $elizasoutput=stripslashes($elizasoutput);
         }
      }
      else
        /* Not isset */
      {
             /* No input from form -- first time displayed */
             $popin="empty";
             $elizasoutput="";
             $_SESSION["conversation"]="OK";
             echo "OK" ;
      }
    /* Cleanup output buffer. Not sure why? */
    ob_end_clean();
    /* Now to html for top of page */
?>

<HTML>
<H2><B>
<a href="http://www.cs.bham.ac.uk/research/projects/poplog/poplog.info.html">POPLOG</a>
POP-11 ELIZA<BR>
<small>
RUNNING ON A LINUX WEB SERVER IN <a href="http://www.cs.bham.ac.uk/">BIRMINGHAM UK</a>
<br>
    A demonstration of a simple Eliza 'chatbot' written in Pop-11
<br>
<small>
    <B>(Very loosely modelled on J.Weizenbaum's Eliza (1966) simulating
    a non-directive (Rogerian) psychotherapist.)</B>
</small>
</small>
</B></H2>
<HR>
<h3><b>
Is Eliza the ghost in the machine?
</b></h3>
<img alt="Picture of a ghost" width="200"
        src="elghost.jpg"/>
<br>
<h3><b>
Every intelligent ghost must contain a machine: an
information-processing machine.
</b></h3>
<FONT size = 3>
<b>
ELIZA HERE!
</b>
</FONT>
<br>
This program simulates a non-directive psychotherapist.
It will appear to engage you in conversation about your problems.
However, it doesn't really understand, as you will soon discover.
It uses 'pattern matching' to attempt to select a relevant response, and
if that fails will produce one of its many pre-stored responses. The
main aim is to keep you talking, until you feel better!
<p>
You can type things into the box to the left of the 'Submit' button,
then if you press the RETURN key or click on the button Eliza will read
what you have written, print your comment and her answer, above the
input panel, and wait for your next input.
<p>
You will get more interesting comments from Eliza if you make
assertions instead of asking questions.
<br>
"Compound" sentences made of two or more sentences joined together are
likely to confuse Eliza.
<br>
[Click on the input box or press the 'TAB' key before typing.]
<HR>

    <?php
        /* Decide whether to show interaction so far or just empyt form */
        if (isset($_POST["elizainput"]))
        {
           if ($popin=="empty")
           {
                /* session_unset(); */
                /*  session_destroy(); */
                echo "RESTARTING<br><b>YOUR NEXT QUESTION PLEASE:</b>";
                $_SESSION["conversation"]="";
                $popin="";
                $elizasoutput="";
           }
           else
           {
                echo "<b>INTERACTION SO FAR:</b>" ;
                echo $_SESSION["conversation"];
                /* plant label to scroll to */
                echo stripslashes("<a name=\"showoutput\"></a>") ;
                /*Show user's last input */
                echo "<p><i>You</i>: $popin<br>";
                /*Show Eliza's response */
                echo stripslashes("<i>Eliza</i>: $elizasoutput");
                echo "<hr>MY RESPONSE IS ABOVE. PLEASE TELL ME SOME MORE";
                /* build up conversation record */
                $_SESSION["conversation"]=$_SESSION["conversation"]."<br><i>You</i>: $popin<br><i>Eliza</i>: $elizasoutput";
           }
       }

       else

       {
            echo stripslashes("<a name=\"showoutput\"></a><br>") ;
            echo "<b>GOOD DAY -- WHAT IS YOUR PROBLEM?</b>";
            $_SESSION["conversation"]="";
       }
    ?>
        <br>
        Please enter your sentence, or
        <span style="color:red;">NEW (upper case)</span> to start again.
        <BR>
        <FONT size = 3>
        <form action="eliza.php#showoutput" method="post">
            <input type="text" size="100" name="elizainput">
            <input type ="submit">
        </form>
        </FONT>

<?php

    echo "<FONT SIZE=\"4\" FACE=\"arial, verdana, helvetica\">Can you guess the rules Eliza uses to answer your questions?<br> </FONT>" ;

    /* Counter was broken between July and Sept 2006 because the ftp site
            was made read only.
        Fixed by moving to
        http://www.cs.bham.ac.uk/research/projects/cogaff/eliza
    */

    /* counter */
    $logfile = fopen("elizalog.txt","r");
    $count = fgets($logfile,100000);
    fclose($logfile);
    $count=$count + 1 ;
    echo "<FONT SIZE=\"3\" FACE=\"arial, verdana, helvetica\">This is question no:</FONT>" ;
    echo "<FONT SIZE=\"3\" FACE=\"arial, verdana, helvetica\">$count (since 25 Sep 2002)</FONT>" ;
    if (isset($_POST["elizainput"]))
    {
    /* Save counter value in file */
    $logfile = fopen("elizalog.txt","w");
    fwrite($logfile, $count);
    fwrite($logfile, "\n");
    fclose($logfile);
    }
?>

<hr>
    <h3>
    <b>
    For an introductory tutorial on implementing Eliza in Pop11 see
        <a href="tutorial.txt">this plain text file.</a>
    <br>
    A more advanced Pop11 tutorial related to this one is
    <a href="http://www.cs.bham.ac.uk/research/projects/poplog/teach/riverchat">here.</a>
    </b>
    </h3>
    <P>
    For more on Pop-11 see
    <a href="http://www.cs.bham.ac.uk/research/poplog/primer/primer.html">
    The pop-11 primer</a>
    <P>
    The Pop-11 source code for a version of Eliza very similar to the
    one demonstrated is
    <a href="http://www.cs.bham.ac.uk/research/poplog/eliza/cgi-bin/eliza2.p">here</a>.
<P>
    This is all part of the Open Source
        <a href="http://www.cs.bham.ac.uk/research/poplog/freepoplog.html">Free Poplog</a>
    web site.
<p>
    For more on the original Eliza see
    <a href="http://i5.nyu.edu/~mm64/x52.9265/january1966.html">http://i5.nyu.edu/~mm64/x52.9265/january1966.html</a>

<HR>
<small>
<a href="http://www.cs.bham.ac.uk/~axs/">Maintained by Aaron Sloman</a>
<BR>
<B>Please email problems to A.Sloman  @  cs.bham.ac.uk</B>
<BR>
With thanks for much help to Mark Roberts for tutorials on PHP.
<BR>
Installed: 25 Sep 2002
<BR>
<small>
15 Sep 2006: Added Eliza tutorial.
Made output scroll to show previous interaction
<BR>
9 Sep 2006: Fixed broken counter by moving to writeable file system
<BR>
24 Aug 2006: Further problems due to change of server.
Moved poplog system to where it could be accessed.
<BR>
 19 Feb 2004: Fixed declaration of "session"
<BR>
4 Feb 2006: Fixed problems after change to new server, and upgraded
</small>
Eliza
</small>

</HTML>
